/*
 * SFO Reader
 * Copyright (C) 2011 Matthieu Milan
 */

#ifndef FILE_H__
#define FILE_H__

#include "sys.h"

struct File_impl;

struct File {
	File_impl *_impl;

	File();
	~File();

	bool open(const char *filename, const char *directory, const char *mode="rb");
	void close();
	bool ioErr() const;
	void seek(uint32_t off);
	void read(void *ptr, uint32_t size);

	uint32_t getInt(uint32_t offset);
	uint8_t getByte(uint32_t offset);
	uint32_t getString(void *ptr, uint32_t offset);
	uint32_t getOffsetKeyName(uint32_t offset);
	uint32_t getKey(void *ptr, uint32_t offset);
	uint32_t getDataType(uint32_t offset);
	uint32_t getSizeOfValue(uint32_t offset);
	uint32_t getValueText(void *ptr, uint32_t offset);
	uint32_t getValueBin(void *ptr, uint32_t offset);
	uint32_t getValueInt(uint32_t offset);
};

#endif // FILE_H__
