/*
 * SFO Reader
 * Copyright (C) 2011 Matthieu Milan
 */

#include "sfo.h"

#define SOFT_VERSION "0.1.0"
#define LISTING 0
#define HELP 1
#define VERSION 2

void printhelp() {
	printf("This program allow you to view the content of a Sony SFO PS3\nUsage:\n  sfo -f FILE [ -r ENTRY ]\n");
}

int main(int argc, char *argv[]) {
	int mode = LISTING;
	char sfo[512] = "";
	char entry[512] = "";

	for (int i = 1; i < argc; i++) {
		if ((strncmp(argv[i], "-f", 2) == 0) && (i + 1 < argc)) {
			snprintf(sfo, strlen(argv[i + 1]) + 1, "%s\n", argv[i + 1]);
			i++;
		} else if (strncmp(argv[i], "-h", 2) == 0) {
			mode = HELP;
		} else if (strncmp(argv[i], "-v", 2) == 0) {
			mode = VERSION;
		} else if ((strncmp(argv[i], "-r", 2) == 0) && (i + 1 < argc)) {
			snprintf(entry, strlen(argv[i + 1]) + 1, "%s\n", argv[i + 1]);
            i++;
		}
	}

	if ((mode != VERSION) && (mode != HELP) && (strcmp(sfo, "") == 0)) {
		printf("Need a -f option pointing the SFO File\n");
		printhelp();

		return EXIT_FAILURE;
	}

	switch (mode) {
		case VERSION:
			printf("PS3 sfo reader - version %s\nCopyrighy © 2011 Matthieu Milan.\n", SOFT_VERSION);
			break;

		case HELP:
			printhelp();
			break;

		case LISTING:
			SFO::work(sfo, entry);
			break;

		default:
			printhelp();
			break;
	}

	return EXIT_SUCCESS;
}
